
		include "asm:include/exec/types.i"
		include "asm:include/exec/nodes.i"

*
* User Structure, See file 'UserBase.DAT.Structure' for details
*

		STRUCTURE	DayDream_User,0

		STRUCT		USER_REALNAME,26
		STRUCT		USER_HANDLE,26
		STRUCT		USER_ORGANIZATION,26
		STRUCT		USER_ZIPCITY,21
		STRUCT		USER_VOICEPHONE,21
		STRUCT		USER_PASSWORD,16
		UBYTE		USER_SCREENLENGTH
		UBYTE		USER_PROTOCOL
		ULONG		USER_TOGGLES
		STRUCT		USER_SIGNATURE,45
		UBYTE		FREESLOT1
		ULONG		USER_ULBYTES
		ULONG		USER_DLBYTES
		UWORD		USER_ULFILES
		UWORD		USER_DLFILES
		UWORD		USER_PUBMESSAGES
		UWORD		USER_PVTMESSAGES
		UWORD		USER_CONNECTIONS
		UBYTE		USER_FILERATIO
		UBYTE		USER_BYTERATIO
		STRUCT		USER_COMPUTERMODEL,21
		UBYTE		FREESLOT2
		ULONG		USER_FREEDLBYTES
		UBYTE		USER_FAILEDLOGINS
		UBYTE		USER_SECURITYLEVEL
		UBYTE		USER_JOINCONFERENCE
		UBYTE		FREESLOT3
		ULONG		USER_FIRSTCALL
		ULONG		USER_LASTCALL
		ULONG		USER_CONFERENCEACC1
		ULONG		USER_CONFERENCEACC2
		UWORD		USER_DAILYTIMELIMIT
		UWORD		USER_ACCOUNT_ID
		UWORD		USER_TIMEREMAINING
		UWORD		USER_FREEDLFILES
		UWORD		USER_FAKEDFILES
		ULONG		USER_FAKEDBYTES
		UWORD		USER_QUESTIONNAIRES
		STRUCT		USER_FREEBLOCK,30
		LABEL		USER_SIZEOF


		STRUCTURE	DayDream_Conference,0

		UBYTE		CONF_NUMBER
		STRUCT		CONF_NAME,40
		STRUCT		CONF_PATH,40

		UBYTE		CONF_FILEAREAS
		UBYTE		CONF_UPLOADAREA

		UBYTE		CONF_MSGBASES
		UBYTE		CONF_COMMENTAREA

		UBYTE		CONF_UNUSED1
		UWORD		CONF_ATTRIBUTES

		STRUCT		CONF_ULPATH,50
		STRUCT		CONF_NEWSCANAREAS,30
		STRUCT		CONF_FREEBLOCK,132

		LABEL		CONF_SIZEOF


		STRUCTURE	DayDream_MsgBase,0

		UBYTE		MSGBASE_FLAGS
		UBYTE		MSGBASE_NUMBER

		UWORD		MSGBASE_LOWEST
		UWORD		MSGBASE_HIGHEST
		UWORD		MSGBASE_MSGLIMIT

		STRUCT		MSGBASE_NAME,21
		STRUCT		MSGBASE_FREEBLOCK2,8

		STRUCT		MSGBASE_FN_TAG,26
		STRUCT		MSGBASE_FN_ORIGIN,58
		UBYTE		MSGBASE_FN_FLAGS
		UWORD		MSGBASE_FN_ZONE
		UWORD		MSGBASE_FN_NET
		UWORD		MSGBASE_FN_NODE
		UWORD		MSGBASE_FN_POINT

		UBYTE		MSGBASE_READACCESS
		UBYTE		MSGBASE_POSTACCESS

		STRUCT		MSGBASE_FREEBLOCK1,68

		LABEL		MSGBASE_SIZEOF


		STRUCTURE	DayDream_Message,0

		UWORD		MSG_NUMBER
		UWORD		MSG_NEXTREPLY
		UWORD		MSG_FLAGS

		STRUCT		MSG_AUTHOR,26
		STRUCT		MSG_RECEIVER,26
		STRUCT		MSG_SUBJECT,68

		ULONG		MSG_CREATION
		ULONG		MSG_RECEIVED

		UWORD		MSG_READCOUNT
		UWORD		MSG_ORIGINAL

		STRUCT		MSG_PASSWORD,16

		UWORD		MSG_FN_PACKET_ORIG_ZONE
		UWORD		MSG_FN_PACKET_ORIG_NET
		UWORD		MSG_FN_PACKET_ORIG_NODE
		UWORD		MSG_FN_PACKET_ORIG_POINT

		UWORD		MSG_FN_ORIG_ZONE
		UWORD		MSG_FN_ORIG_NET
		UWORD		MSG_FN_ORIG_NODE
		UWORD		MSG_FN_ORIG_POINT

		ULONG		MSG_FN_MSGID

		UWORD		MSG_FN_DEST_ZONE
		UWORD		MSG_FN_DEST_NET
		UWORD		MSG_FN_DEST_NODE
		UWORD		MSG_FN_DEST_POINT

		STRUCT		MSG_FREEBLOCK,118

		LABEL		MSG_SIZEOF

MSG_FLAGS_PRIVATE	=	1
MSG_FLAGS_DELETED	=	2

		STRUCTURE	DayDream_Protocol,0

		UBYTE		PROTOCOL_ID
		STRUCT		PROTOCOL_NAME,20

		UBYTE		PROTOCOL_EFFICIENCY

		STRUCT		PROTOCOL_XPRLIBRARY,30
		STRUCT		PROTOCOL_INITSTRING,30

		UBYTE		PROTOCOL_FLAGS

		STRUCT		PROTOCOL_FREEBLOCK,117

		LABEL		PROTOCOL_SIZEOF


		STRUCTURE	DayDream_DisplayMode,0

		UBYTE		DISPLAY_ID
		STRUCT		DISPLAY_PATH,9
		UWORD		DISPLAY_ATTRIBUTES

		UBYTE		DISPLAY_INCOMING_TABLEID
		UBYTE		DISPLAY_OUTGOING_TABLEID

		STRUCT		DISPLAY_FONT,20
		UWORD		DISPLAY_FONTSIZE
		UBYTE		DISPLAY_STRINGS
		STRUCT		DISPLAY_FREEBLOCK,63

		LABEL		DISPLAY_SIZEOF


		STRUCTURE	DayDream_AccessLevel,0

		UBYTE		ACCESS_SECLEVEL
		UBYTE		ACCESS_PRESETID
		UWORD		ACCESS_FREEFILES
		ULONG		ACCESS_FREEBYTES
		STRUCT		ACCESS_DESCRIPTION,29
		UBYTE		ACCESS_STATUS
		STRUCT		ACCESS_FREEBLOCK,12

		LABEL		ACCESS_SIZEOF


		STRUCTURE	DayDream_MainConfig,0

		STRUCT		CFG_BOARDNAME,26
		STRUCT		CFG_SYSOPNAME,26
		STRUCT		CFG_SERIALCODE,11
		STRUCT		CFG_FILEVIEWER,21
		STRUCT		CFG_CHATDLPATH,41

		UBYTE		CFG_DISPLAYMODE

		ULONG		CFG_FREE2
		UBYTE		CFG_JOINIFAUTOJOINFAILS
		STRUCT		CFG_COLORSYSOP,11
		STRUCT		CFG_COLORUSER,11

		UBYTE		CFG_FREE

		STRUCT		CFG_SYSTEMPW,16
		STRUCT		CFG_NEWUSERPW,16
		STRUCT		CFG_OLUSEREDPW,16

		ULONG		CFG_UNIQUEMSGNUMBER

		UBYTE		CFG_DIRFILEBUFFERSIZE

		UBYTE		CFG_NEWUSERPRESETID

		ULONG		CFG_IDLETIMEOUT

		ULONG		CFG_FREEHDDSPACE

		ULONG		CFG_FLAGS
		STRUCT		CFG_SHELLPW,16

		STRUCT		CFG_ALIENS,40
		STRUCT		CFG_FREESLOT1,3724

		LABEL		CFG_SIZEOF


		STRUCTURE	DayDream_Multinode,0

		UBYTE		MULTI_NODE
		UBYTE		MULTI_DEVICE
		UWORD		MULTI_MINBAUD
		UWORD		MULTI_MINBAUDNEW
		UWORD		MULTI_SCREENWIDTH
		UWORD		MULTI_SCREENLENGTH
		STRUCT		MULTI_FONTNAME,20
		UWORD		MULTI_FONTSIZE
		UBYTE		MULTI_SCREENFLAGS
		UBYTE		MULTI_OTHERFLAGS
		STRUCT		MULTI_COMMAND,32
		BYTE		MULTI_PRIORITY
		STRUCT		MULTI_TEMPORARY,33
		STRUCT		MULTI_FREE,100
		LABEL		MULTI_SIZEOF

		STRUCTURE	DayDream_Version,0

		STRUCT		VER_VERSION,36

		UWORD		VER_CONFERENCESIZE
		UWORD		VER_MSGBASESIZE
		UWORD		VER_USERSIZE
		UWORD		VER_ACCESSLEVELSIZE
		UWORD		VER_ARCHIVERSIZE
		UWORD		VER_MAINCONFIGSIZE
		UWORD		VER_EXTCMDSIZE
		UWORD		VER_IODEVICESIZE
		UWORD		VER_MESSAGESIZE
		UWORD		VER_MULTINODESIZE
		UWORD		VER_EXTPROTOCOLSIZE
		UWORD		VER_DISPLAYSIZE
		UWORD		VER_SECURITYSIZE
		STRUCT		VER_FREEBLOCK,38

		LABEL		VER_SIZEOF


		STRUCTURE	DayDream_IO_Device,0

		UWORD		IOD_UNIT
		ULONG		IOD_DTERATE

		STRUCT		IOD_NAME,26
		STRUCT		IOD_PREINIT,16
		STRUCT		IOD_OFFHOOK,16
		STRUCT		IOD_ANSWER,16
		STRUCT		IOD_INITIALIZE,61

		STRUCT		IOD_RESPONSE_OK,16
		STRUCT		IOD_RESPONSE_RING,16
		STRUCT		IOD_RESPONSE_NOCARRIER,16
		STRUCT		IOD_RESPONSE_CONNECT,16

		STRUCT		IOD_SPEEDID1,10
		STRUCT		IOD_SPEEDID2,10
		STRUCT		IOD_SPEEDID3,10
		STRUCT		IOD_SPEEDID4,10
		STRUCT		IOD_SPEEDID5,10
		STRUCT		IOD_SPEEDID6,10
		STRUCT		IOD_SPEEDID7,10
		STRUCT		IOD_SPEEDID8,10
		STRUCT		IOD_SPEEDID9,10
		STRUCT		IOD_SPEEDID0,10

		STRUCT		IOD_ERRORCORRECTIONID,7

		UWORD		IOD_SPEED1
		UWORD		IOD_SPEED2
		UWORD		IOD_SPEED3
		UWORD		IOD_SPEED4
		UWORD		IOD_SPEED5
		UWORD		IOD_SPEED6
		UWORD		IOD_SPEED7
		UWORD		IOD_SPEED8
		UWORD		IOD_SPEED9
		UWORD		IOD_SPEED0

		UBYTE		IOD_CONNECTDELAY
		UBYTE		IOD_INITDELAY

		ULONG		IOD_SETUPBITS

		STRUCT		IOD_FREEBLOCK1,62

		LABEL		IOD_SIZEOF


		STRUCTURE	DayDream_Archiver,0

		UBYTE		ARC_FLAGS

		STRUCT		ARC_EXTENSION,6
		STRUCT		ARC_NAME,21

		STRUCT		ARC_CMD_TEXT,41
		STRUCT		ARC_CMD_EXTRACT,41
		STRUCT		ARC_CMD_ADD,41

		STRUCT		ARC_CORRUPTED1,16
		STRUCT		ARC_CORRUPTED2,16
		STRUCT		ARC_CORRUPTED3,16

		STRUCT		ARC_EXTRACTFILEID,41

		STRUCT		ARC_ADDFILEID,41
		STRUCT		ARC_FREEBLOCK,119

		LABEL		ARCHIVER_SIZEOF


		STRUCTURE	DayDream_Schedule,0

		UBYTE		SCHDL_HOUR
		UBYTE		SCHDL_BITS

		STRUCT		SCHDL_SYSTEMPW,16
		STRUCT		SCHDL_NEWUSERPW,16

		STRUCT		SCHDL_FREEBLOCK1,166

		LABEL		SCHDL_SIZEOF


		STRUCTURE	ExternalComand,0

		STRUCT		EXT_NAME,11
		UBYTE		EXT_CMDTYPE
		UBYTE		EXT_SECLEVEL
		STRUCT		EXT_COMMAND,87

		STRUCT		EXT_FREEBLOCK1,100

		LABEL		EXT_SIZEOF

		STRUCTURE	FileChainItem,0

		STRUCT		FCI_HEADER,MLN_SIZE
		STRUCT		FCI_PATH,72
		STRUCT		FCI_FILE,32
		ULONG		FCI_SIZE
		ULONG		FCI_BITS
		UBYTE		FCI_CONF
		LABEL		FCI_SIZEOF

		STRUCTURE	DD_Seclevel,0

		UBYTE		SEC_SECLEVEL
		UBYTE		SEC_FILERATIO
		UBYTE		SEC_BYTERATIO
		UBYTE		SEC_PAGESPERCALL
		UWORD		SEC_DAILYTIME
		ULONG		SEC_CONFERENCEACC1
		ULONG		SEC_CONFERENCEACC2
		ULONG		SEC_ACCESSBITS1
		ULONG		SEC_ACCESSBITS2
		ULONG		SEC_ACCESSBITS3
		ULONG		SEC_ACCESSBITS4
		STRUCT		SEC_PILLU,20
		LABEL		SEC_SIZEOF

		STRUCTURE	DIFace,0
		APTR		dif_DDPort
		APTR		dif_ReplyPort
		APTR		dif_Message
		APTR		dif_Buffer
		LABEL		dif_SIZEOF

		STRUCTURE	DDPointers,0
		ULONG		dp_Connecttype
		APTR		dp_Server
		APTR		dp_Archivers
	 	APTR		dp_DayDream
		APTR		dp_Display
		APTR		dp_CurrDisplay
		APTR		dp_Conferences
		APTR		dp_CurrConf
	 	APTR		dp_CurrBase
		APTR		dp_Protocols
		APTR		dp_CurrUser
		APTR		dp_Externals
		APTR		dp_Schedule		
		APTR		dp_DoorParams				
		ULONG		dp_BpsRate				
		APTR		dp_NodeStructure			
		APTR		dp_CurrentNode
		APTR		dp_InComingTable			
		APTR		dp_OutGoingTable			
		APTR		dp_Security		
		APTR		dp_Selected				
		APTR		dp_IODevice
		APTR		dp_DoorCmd
		APTR		dp_Multinodes
		ULONG		dp_Lastcall
		APTR		dp_FileChain
		STRUCT		dp_Future,38
		LABEL		dp_SIZEOF

		BITDEF	DP,HIDDEN,0
		BITDEF	DP,NOCRLF,1
		BITDEF	DP,FILENAME,2

		BITDEF	DD,ADDEXTENSION,0
		BITDEF	DD,SHOWERROR,1
		BITDEF	DD,STRIPKLUDGES,2
		BITDEF	DD,CHECKCONF,3
		BITDEF	DD,CHECKACS,4
		BITDEF	DD,STRIPCTRL,5



DYESNO_NO	= 0
DYESNO_YES	= 1
DYESNO_ERROR	= -1

		BITDEF	HOTKEY,SHOWCHAR,0
		BITDEF	HOTKEY,ADDLF,1
		BITDEF	HOTKEY,CURSOR,2
		BITDEF  HOTKEY,DETECT,3

		BITDEF	FLAGFILE,FREE,0

		BITDEF	JOINCONF,ASKNEW,0
		BITDEF	JOINCONF,QUICK,1
		BITDEF	JOINCONF,SKIPTXT,2

		BITDEF	CMB,SHOWMENU,0
		BITDEF	CMB,QUICK,1

		BITDEF	SEC,DOWNLOAD,0
		BITDEF	SEC,UPLOAD,1
		BITDEF	SEC,READMSG,2
		BITDEF	SEC,ENTERMSG,3
		BITDEF	SEC,PAGE,4
		BITDEF	SEC,COMMENT,5
		BITDEF	SEC,BULLETINS,6
		BITDEF	SEC,FILESCAN,7
		BITDEF	SEC,NEWFILES,8
		BITDEF	SEC,ZIPPYSEARCH,9
		BITDEF	SEC,RUNDOOR,10
		BITDEF	SEC,JOINCONF,11
		BITDEF	SEC,CHANGEMSGAREA,12
		BITDEF	SEC,CHANGEINFO,13
		BITDEF	SEC,RELOGIN,14
		BITDEF	SEC,TAGEDITOR,15
		BITDEF	SEC,USERSTATS,16
		BITDEF	SEC,VIEWTIME,17
		BITDEF	SEC,HYDRATRANSFER,18
		BITDEF	SEC,EXPERTMODE,19
		BITDEF	SEC,EALLMESSAGE,20
		BITDEF	SEC,FIDOMESSAGE,21
		BITDEF	SEC,PUBLICMESSAGE,22
		BITDEF	SEC,READALL,23
		BITDEF	SEC,USERED,24
		BITDEF	SEC,VIEWLOG,25
		BITDEF	SEC,SYSOPDL,26
		BITDEF	SEC,USERLIST,27
		BITDEF	SEC,DELETEANY,28
		BITDEF	SEC,REMOTESHELL,29
		BITDEF	SEC,WHO,30
		BITDEF	SEC,MOVEFILE,31
		BITDEF	SEC,SELECTFILECONFS,0
		BITDEF	SEC,SELECTMSGBASES,1
		BITDEF	SEC,SENDNETMAIL,2
		BITDEF	SEC,OLM,3

